#!/usr/bin/perl

#    ADC2000NG - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
@data=();
$bxalt=~s/\'/\\\'/g;
open (F,"<$basepath/domains.db");
flock(F,$LOCK_EX);
@domains=<F>;
flock(F,$LOCK_UN);
close (F);
foreach(@domains)
{
	chop;
	($dom,$dcou)=split("\t",$_);
	$domain{$dom}=$dcou;
}
@userhost=split(/\./,$ENV{REMOTE_HOST});
$ntld=pop(@userhost);
$domain{$ntld}="NOTHING" if (!$domain{$ntld});
$ntld=$domain{$ntld};
($ldate=scalar gmtime(time+$gmtzone*3600))=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar gmtime(time+$gmtzone*3600));
($hours)=split(":",$time);
if ($hours==0){$hourr=23;}
else {$hourr=$hours-1;}
$lmon=$cal{$month};
$ldte=$date;
$lmon="0".$lmon if (length($lmon)==1);
$ldte="0".$date if (length($date)==1);
$lastact="$year$lmon$ldte";
$getcode=$ENV{QUERY_STRING};
$getcode=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
($user,$spot,$random)=split("&",$getcode);
if (!$user || $spot eq undef || !$random || !(-d "$basepath/$user"))
{
	print "HTTP/1.0 200 OK\n";
	print "content-type: text/html\n\n";
	print qq~document.write(\'<table border=0 cellpadding=0 cellspacing=0><tr><td><font size=2><b>Wrong banner code</b></font></td></tr></table>\')~;
	exit;
}
$ccuc="adcngb$user$spot";
unless ($cookie{$ccuc})
{
	$cancount=1;
}
open (F,"$basepath/proxy.db");
flock(F,$LOCK_EX);
@proxy=<F>;
flock(F,$LOCK_UN);
close (F);
if (@proxy)
{
$proxy=join("",@proxy);
$proxy=~s/\n/#/g;
$proxy="#$proxy";
$rem_adr=$ENV{REMOTE_ADDR};
$rem_host=$ENV{REMOTE_HOST};
if ($proxy=~/\#$rem_adr\#/ || $proxy=~/\#$rem_host\#/)
{
	print "HTTP/1.0 200 OK\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	print qq~document.write(\'<table border=0 cellpadding=0 cellspacing=0><tr><td><font size=2><b></b></font></td></tr></table>\')~;
	exit;
}
}
if ($ENV{HTTP_REFERER})
{
	if (-e "$basepath/$user/referer.bx")
	{
		if (-s "$basepath/$user/referer.bx"<100000)
		{
			open(F,"+<$basepath/$user/referer.bx");
			flock(F,$LOCK_EX);
			@refers=<F>;
			foreach(@refers)
			{
				chop;
				($refers,$c_refers)=split("\t",$_);
				$refers{$refers}=$c_refers;
			}
			$refers=$ENV{HTTP_REFERER};
			$refers{$refers}=$refers{$refers}+1;
			truncate(F,0);
			seek(F,0,0);
			foreach $key (keys %refers)
			{
				print F "$key\t$refers{$key}\n";
			}
			flock(F,$LOCK_UN);
			close(F);
		}
	}
	else
	{
		open(F,">$basepath/$user/referer.bx");
		flock(F,$LOCK_EX);
		print F "$ENV{HTTP_REFERER}\t1\n";
		flock(F,$LOCK_UN);
		close(F);
	}
}
if (!$ENV{HTTP_REFERER} && $logrefererfault)
{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tCant resolve referer address\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
if (!$ENV{HTTP_USER_AGENT} && $logagentfault)
{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tCant resolve user agent\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
if ($cookie{adcrand}==$random && $logcookieduplicates)
{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tUsed same random number from one person\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
$templine="adcngac$user$spot";
if ($cookie{$templine})
{
	($howmany,$fromwhere)=split("#",$cookie{$templine});
	$howmany++;
	$fromwhere.=",$ENV{REMOTE_ADDR}" unless ($fromwhere=~/$ENV{REMOTE_ADDR}/);
	@fromwhere=split(",",$fromwhere);
	$totalfrom=scalar (@fromwhere);
	if ($howmany>$logallowimpperbrowser || $totalfrom>$logallowipperbrowser)
	{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tLimit for impressions or IPs per browser is exceed (IMP:$howmany IPS: $totalfrom)\t$fromwhere\n";
	flock(F,$LOCK_UN);
	close(F);
	}
}
else
{
	$howmany=1;
	$fromwhere=$ENV{REMOTE_ADDR};
}
open (F,"<$basepath/$user/target");
flock(F,$LOCK_EX);
@targa=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,">$basepath/$user/lastact");
flock(F,$LOCK_EX);
print F $lastact;
flock(F,$LOCK_UN);
close (F);
if (-s "$basepath/blitz.db")
{
	open(F,"+<$basepath/blitz.db");
	flock(F,$LOCK_EX);
	@blitz=<F>;
	truncate (F,0);
	seek (F,0,0);
	srand;
	$item=$blitz[int(rand scalar(@blitz))];
	chop($item);
	($uname,$ucred)=split("\t",$item);
	if ($uname ne $user && (-e "$adcpath/banners$spot/$uname.ext" || -e "$adcpath/banners$spot/$uname.gif" || -e "$adcpath/banners$spot/$uname.jpg"))
	{
	$ucred--;
	foreach(@blitz)
	{
		($uuname,$uucred)=split("\t",$_);
		if ($uuname eq $uname)
		{
			next if ($ucred==0);
			$_="$uname\t$ucred\n";
		}
		push(@nblitz,$_);
	}
	print F @nblitz;
	$username=$uname;
	$flag=1;
	$blitzdone=1;
	}
	else {print F @blitz;}
	flock(F,$LOCK_UN);
	close(F);
}
open (F,"<$basepath/target.db");
flock(F,$LOCK_EX);
@targets=<F>;
flock(F,$LOCK_UN);
close(F);
foreach(@targets)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$targets{$tusr}=$tval;
}
open (FICR,"+<$basepath/credits.db");
flock(FICR,$LOCK_EX);
@credits=<FICR>;
foreach(@credits)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$credit{$tusr}=$tval;
}
if (!$blitzdone)
{
	open (F, "<$basepath/adcenter.db");
	flock(F,$LOCK_EX);
	while($line=<F>)
	{
		chop($line);
		($username,$url,$usrgroup,$country,$ratio,$referuser,$weight)=split("\t",$line);
		if ($username eq $user)
		{
			$tgroup=$usrgroup;
			$tcountry=$country;
			$userratio=$ratio;
			$refus=$referuser;
			$usersurl=$url;
			next;
		}
		$weight=1 if (!$weight || $weight==0);
		($imp,$clc)=split(" ",$credit{$username});
		@targs=split("#BETWEENTRG#",$targets{$username});
		$templine_ss="adcngbxshown$spot";
		if ($targa[1]=~/\b$country\b/ && $targa[2]=~/\b$usrgroup\b/ && ($targs[0]=~/\b$tgroup\b/ || !$tgroup) && ($imp>1*$compesys[$spot] || $clc>1*$compesys[$spot] || -e "$basepath/$username/nonexpired") && ($targs[1]=~/\b$tcountry\b/ || $targs[1]=~/\b$ntld\b/ || !$tcountry) && (-e "$adcpath/banners$spot/$username.gif" || -e "$adcpath/banners$spot/$username.jpg" || (-e "$adcpath/banners$spot/$username.ext" && -e "$basepath/$user/showrmb")) && !(-e "$basepath/$username/dflag") && (!$smartshow || !($cookie{$templine_ss}=~/\b$username\b/)))
		{
		$j=0;
		while ($j<$weight)
		{
			push(@data,$username);
			$j++;
		}
		}
	}
	flock(F,$LOCK_UN);
	close (F);
	while ($i<@data)
	{
		srand;
		$item=int(rand (@data));
		$username=$data[$item];
		open (FL,"+<$basepath/$username/timeman$spot");
		flock(FL,$LOCK_EX);
		@work=<FL>;
		($onwork,$offwork)=split("\t",$work[$hours]);
		if ($onwork<$offwork)
		{
			$onwork=$onwork+1;
			$work[$hours]="$onwork\t$offwork";
			($onwork,$offwork)=split("\t",$work[$hourr]);
			$work[$hourr]="0\t$offwork";
			truncate (FL,0);
			seek (FL,0,0);
			print FL @work;
			flock(FL,$LOCK_UN);
			close(FL);
			$flag=1;
			last;
		}
		flock(FL,$LOCK_UN);
		close(FL);
		splice(@data,$item,1);
	}
}
$username=$yourname if (!$flag);
($rat1,$rat2)=split(":",$userratio);
if ($rat2){$userratio=$rat1/$rat2;}else{$userratio=0;}
if ($userratio=~/\./){$userratio=substr($userratio,0,5);}
($imp,$clc)=split(" ",$credit{$user});
$imp=$imp+$userratio*$compesys[$spot] if ($cancount);
$credit{$user}="$imp $clc";
($imp,$clc)=split(" ",$credit{$username});
$imp=$imp-1*$compesys[$spot] if ($imp>1*$compesys[$spot]);
$credit{$username}="$imp $clc";
if ($refus)
{
($rat1,$rat2)=split(":",$refratio);
if ($rat2){$refratio=$rat1/$rat2;}else{$refratio=0;}
if ($refratio=~/\./){$refratio=substr($refratio,0,5);}
($imp,$clc)=split(" ",$credit{$refus});
$imp=$imp+$refratio*$compesys[$spot] if ($cancount);
$credit{$refus}="$imp $clc";
}
truncate(FICR,0);
seek(FICR,0,0);
foreach $key (keys %credit){print FICR "$key\t$credit{$key}\n";}
flock(FICR,$LOCK_UN);
close (FICR);
if ($refus && $cancount)
{
	open (F,"+<$basepath/$refus/referal");
	flock(F,$LOCK_EX);
	$credit=<F>;
	$credit=$credit+$refratio*$compesys[$spot];
	truncate (F,0);
	seek (F,0,0);
	print F $credit;
	flock(F,$LOCK_UN);
	close(F);
}

unless (-e "$basepath/$username/impressions$spot")
{
	open (F,">$basepath/$username/impressions$spot");
	flock(F,$LOCK_EX);
	flock(F,$LOCK_UN);
	close (F);
}
open (STAT,"+<$basepath/$username/impressions$spot");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	$stats{$tkey}=$tval;
}
@stats=split ("#",$stats{$ldate});
$stats[$hours]=$stats[$hours]+1;
$stats{$ldate}=join("#",@stats[0..23]);
truncate(STAT,0);
seek(STAT,0,0);
foreach $key (keys %stats){print STAT "$key\t$stats{$key}\n";}
flock(STAT,$LOCK_UN);
close (STAT);
if (-e "$basepath/$username/affiliate")
{
open (F,"+<$basepath/$username/affiliate");
flock(F,$LOCK_EX);
@lines=<F>;
foreach (@lines)
{
	($arg1,$arg2,$arg3,$arg4)=split("\t",$_);
	if ($arg1 eq $user)
	{
		$arg3++;
		$_="$arg1\t$arg2\t$arg3\t$arg4";
		$foundflag=1;
		last;
	}
}
push (@lines,"$user\t$usersurl\t1\t0\n") if (!$foundflag);
truncate(F,0);
seek(F,0,0);
print F @lines;
flock(F,$LOCK_UN);
close (F);
}
else
{
open (F,">$basepath/$username/affiliate");
flock(F,$LOCK_EX);
print F "$user\t$usersurl\t1\t0\n";
flock(F,$LOCK_UN);
close (F);
}
unless (-e "$basepath/$user/affilx")
{
	open (F,">$basepath/$user/affilx");
	flock(F,$LOCK_EX);
	print F "0";
	flock(F,$LOCK_UN);
	close (F);
}
open (F,"+<$basepath/$user/affilx");
flock(F,$LOCK_EX);
$affilx_data=<F>;
$affilx_data+=1;
truncate(F,0);
seek(F,0,0);
print F $affilx_data;
flock(F,$LOCK_UN);
close (F);

($day,$date,$month,$time,$year)=split(" ",scalar gmtime(time+$smartshowdelay*60*60*24));
$month="0$month" if (length($month)==1);
($dayb,$dateb,$monthb,$timeb,$yearb)=split(" ",scalar gmtime(time+$blocker));
if ($username ne $yourname)
{
	$tmp_cook="adcngbxshown$spot";
	$cookie{$tmp_cook}.=",$username";
	$ch_c=1;
}
if (-e "$adcpath/banners$spot/$username.gif")
{
	print "HTTP/1.0 200 OK\n";
	print "P3P: CP=\"UNI\"\n";
	print "set-cookie: adcngac$user$spot=$howmany#$fromwhere; \n";
	print "set-cookie: adcngb$user$spot=1; expires=$dayb, $monthb-$dateb-$yearb $timeb GMT; \n" if ($blocker && !$cookie{$ccuc});
	print "set-cookie: adcrand=$random; \n";
	print "set-cookie: $tmp_cook=$cookie{$tmp_cook}; expires=$day, $month-$date-$year $time GMT; \n" if ($smartshow==1 && $ch_c);
	print "content-type: application/x-javascript\n\n";
	$minibannerc=qq~<br><a href="$cgi/adcclick.pl?$user" target="_top"><img src="$adcenter/images/network$spot.gif" border=0 width=$banwidth[$spot] height=$mbanheight></a>~ if ($enablemb[$spot]);
	print qq~document.write(\'<p><a href="$cgi/adcrdst.pl?$username&$spot&$user" target="_top"><img src="$adcenter/banners$spot/$username.gif" border=0 width=$banwidth[$spot] height=$banheight[$spot] alt="$bxalt"></a>$minibannerc</p>\')~;
}
elsif (-e "$adcpath/banners$spot/$username.jpg")
{
	print "HTTP/1.0 200 OK\n";
	print "P3P: CP=\"UNI\"\n";
	print "set-cookie: adcngac$user$spot=$howmany#$fromwhere; \n";
	print "set-cookie: adcngb$user$spot=1; expires=$dayb, $monthb-$dateb-$yearb $timeb GMT; \n" if ($blocker && !$cookie{$ccuc});
	print "set-cookie: adcrand=$random; \n";
	print "set-cookie: $tmp_cook=$cookie{$tmp_cook}; expires=$day, $month-$date-$year $time GMT; \n" if ($smartshow==1 && $ch_c);
	print "content-type: application/x-javascript\n\n";
	$minibannerc=qq~<br><a href="$cgi/adcclick.pl?$user" target="_top"><img src="$adcenter/images/network$spot.gif" border=0 width=$banwidth[$spot] height=$mbanheight></a>~ if ($enablemb[$spot]);
	print qq~document.write(\'<p><a href="$cgi/adcrdst.pl?$username&$spot&$user" target="_top"><img src="$adcenter/banners$spot/$username.jpg" border=0 width=$banwidth[$spot] height=$banheight[$spot] alt="$bxalt"></a>$minibannerc</p>\')~;
}
elsif (-e "$adcpath/banners$spot/$username.ext")
{
	open(F,"$adcpath/banners$spot/$username.ext");
	$comline=<F>;
	close(F);
	print "HTTP/1.0 200 OK\n";
	print "P3P: CP=\"UNI\"\n";
	print "set-cookie: adcngac$user$spot=$howmany#$fromwhere; \n";
	print "set-cookie: adcngb$user$spot=1; expires=$dayb, $monthb-$dateb-$yearb $timeb GMT; \n" if ($blocker && !$cookie{$ccuc});
	print "set-cookie: adcrand=$random; \n";
	print "set-cookie: adc2000ng$username$spot=$user; \n";
	print "set-cookie: $tmp_cook=$cookie{$tmp_cook}; expires=$day, $month-$date-$year $time GMT; \n" if ($smartshow==1 && $ch_c);
	print "content-type: application/x-javascript\n\n";
	$minibannerc=qq~<script language="Javascript" type="text/javascript" src="$cgi/nph-adcgetmb.pl?$user&$spot"></script>~ if ($enablemb[$spot]);
	print qq~document.write(\'<table border=0 cellpadding=0 cellspacing=0><tr><td>$comline</td></tr><tr><td>$minibannerc</td></tr></table>\')~;
}
