#!/usr/bin/perl

#    ADC2000NG - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cook{$field}=$value;
	}
}
@data=();
open (F,"$basepath/proxy.db");
flock(F,$LOCK_EX);
@proxy=<F>;
flock(F,$LOCK_UN);
close (F);
if (@proxy)
{
$proxy=join("",@proxy);
$proxy=~s/\n/#/g;
$proxy="#$proxy";
$rem_adr=$ENV{REMOTE_ADDR};
$rem_host=$ENV{REMOTE_HOST};
if ($proxy=~/\#$rem_adr\#/ || $proxy=~/\#$rem_host\#/)
{
	print "HTTP/1.0 200 OK\n" if ($sysid eq "Windows");
	print "content-type: application/x-javascript\n\n";
	print qq~ ~;
	exit;
}
}
unless ($cook{adc2000id})
{
@data=();
open (F,"<$basepath/domains.db");
flock(F,$LOCK_EX);
@domains=<F>;
flock(F,$LOCK_UN);
close (F);
foreach(@domains)
{
	chop;
	($dom,$dcou)=split("\t",$_);
	$domain{$dom}=$dcou;
}
@userhost=split(/\./,$ENV{REMOTE_HOST});
$ntld=pop(@userhost);
$domain{$ntld}="NOTHING" if (!$domain{$ntld});
$ntld=$domain{$ntld};
($ldate=scalar gmtime(time+$gmtzone*3600))=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar gmtime(time+$gmtzone*3600));
($hours)=split(":",$time);
if ($hours==0){$hourr=23;}
else {$hourr=$hours-1;}
$lmon=$cal{$month};
$ldte=$date;
$lmon="0".$lmon if (length($lmon)==1);
$ldte="0".$date if (length($date)==1);
$lastact="$year$lmon$ldte";
$time=~s/://g;

($user)=split("&",$ENV{QUERY_STRING});
if (!$user || !(-d "$basepath/$user"))
{
	print "HTTP/1.0 200 OK\n";
	print "content-type: text/html\n\n";
	print qq~document.write(\'<table border=0 cellpadding=0 cellspacing=0><tr><td><font size=2><b>Wrong popup code</b></font></td></tr></table>\')~;
	exit;
}
if ($ENV{HTTP_REFERER})
{
	if (-e "$basepath/$user/referer.pop")
	{
		if (-s "$basepath/$user/referer.pop"<100000)
		{
			open(F,"+<$basepath/$user/referer.pop");
			flock(F,$LOCK_EX);
			@refers=<F>;
			foreach(@refers)
			{
				chop;
				($refers,$c_refers)=split("\t",$_);
				$refers{$refers}=$c_refers;
			}
			$refers=$ENV{HTTP_REFERER};
			$refers{$refers}=$refers{$refers}+1;
			truncate(F,0);
			seek(F,0,0);
			foreach $key (keys %refers)
			{
				print F "$key\t$refers{$key}\n";
			}
			flock(F,$LOCK_UN);
			close(F);
		}
	}
	else
	{
		open(F,">$basepath/$user/referer.pop");
		flock(F,$LOCK_EX);
		print F "$ENV{HTTP_REFERER}\t1\n";
		flock(F,$LOCK_UN);
		close(F);
	}
}
if (!$ENV{HTTP_REFERER} && $logrefererfault)
{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tCant resolve referer address\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
if (!$ENV{HTTP_USER_AGENT} && $logagentfault)
{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tCant resolve user agent\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
$templine="adcngacpop$user";
if ($cook{$templine})
{
	($howmany,$fromwhere)=split("#",$cook{$templine});
	$howmany++;
	$fromwhere.=",$ENV{REMOTE_ADDR}" unless ($fromwhere=~/$ENV{REMOTE_ADDR}/);
	@fromwhere=split(",",$fromwhere);
	$totalfrom=scalar (@fromwhere);
	if ($howmany>$logallowimpperbrowser || $totalfrom>$logallowipperbrowser)
	{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tLimit for impressions or IPs per browser is exceed (IMP:$howmany IPS: $totalfrom)\t$fromwhere\n";
	flock(F,$LOCK_UN);
	close(F);
	}
}
else
{
	$howmany=1;
	$fromwhere=$ENV{REMOTE_ADDR};
}
open (F,"<$basepath/$user/target");
flock(F,$LOCK_EX);
@targa=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,">$basepath/$user/lastact");
flock(F,$LOCK_EX);
print F $lastact;
flock(F,$LOCK_UN);
close (F);
open (F,"<$basepath/target.db");
flock(F,$LOCK_EX);
@targets=<F>;
flock(F,$LOCK_UN);
close(F);
foreach(@targets)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$targets{$tusr}=$tval;
}
open (FICR,"<$basepath/credits.pop");
flock(FICR,$LOCK_EX);
@credits=<FICR>;
flock(FICR,$LOCK_UN);
close (FICR);
foreach(@credits)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$credit{$tusr}=$tval;
}
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
while($line=<F>)
{
	chop($line);
	($username,$url,$usrgroup,$country,$ratio,$referuser,$weight)=split("\t",$line);
	if ($username eq $user)
	{
		$tgroup=$usrgroup;
		$tcountry=$country;
		$userratio=$ratio;
		$refus=$referuser;
		$usersurl=$url;
		next;
	}
	$weight=1 if (!$weight || $weight==0);
	@targs=split("#BETWEENTRG#",$targets{$username});
	$templine_ss="adcngpopshown";
	if ($targa[2]=~/\b$usrgroup\b/ && ($targs[0]=~/\b$tgroup\b/ || !$tgroup) && ($credit{$username}>1 || -e "$basepath/$username/nonexpired") && ($targs[1]=~/\b$tcountry\b/ || $targs[1]=~/\b$ntld\b/ || !$tcountry) && !(-e "$basepath/$username/dflag") && (!$smartshow || !($cook{$templine_ss}=~/\b$username\b/)))
	{
	$j=0;
	while ($j<$weight)
	{
		push(@data,$username);
		$j++;
	}
	}
}
flock(F,$LOCK_UN);
close (F);
$i=0;
srand;
$item=int(rand (@data));
$username=$data[$item];
$username=$yourname unless (@data);
if (-e "$basepath/$username/affiliate.pop")
{
open (F,"+<$basepath/$username/affiliate.pop");
flock(F,$LOCK_EX);
@lines=<F>;
foreach (@lines)
{
	($arg1,$arg2,$arg3,$arg4)=split("\t",$_);
	if ($arg1 eq $user)
	{
		$arg3++;
		$_="$arg1\t$arg2\t$arg3\t$arg4";
		$foundflag=1;
		last;
	}
}
push (@lines,"$user\t$usersurl\t1\t0\n") if (!$foundflag);
truncate(F,0);
seek(F,0,0);
print F @lines;
flock(F,$LOCK_UN);
close (F);
}
else
{
open (F,">$basepath/$username/affiliate.pop");
flock(F,$LOCK_EX);
print F "$user\t$usersurl\t1\t0\n";
flock(F,$LOCK_UN);
close (F);
}

print "HTTP/1.0 200 OK\n";
print "P3P: CP=\"UNI\"\n";
print "set-cookie: adcngacpop$user=$howmany#$fromwhere; \n";
print "content-type: application/x-javascript\n\n";
print qq~function MakeBottomWindow() { document.cookie="adc2000c=1 ;";var url = '$cgi/adcrdpop.pl?$username&$user';var width = '$popwidth';var height = '$popheight';var p = 'scrollbars=yes,resizable=yes,toolbar=no,menubar=no,status=no,location=no,left=85,top=20,height='+height+',width='+width;var start;if (document.cookie.indexOf('adc2000c=')>=0) {var botwin = window.open(url,"POPUP",p);self.focus();}} MakeBottomWindow();~;
}
else
{
print "HTTP/1.0 200 OK\n";
print "content-type: application/x-javascript\n\n";
print " ";
}
